# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pulpcore.client.pulp_deb.configuration import Configuration


class DebReleaseComponent(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'component': 'str',
        'distribution': 'str',
        'codename': 'str',
        'suite': 'str'
    }

    attribute_map = {
        'component': 'component',
        'distribution': 'distribution',
        'codename': 'codename',
        'suite': 'suite'
    }

    def __init__(self, component=None, distribution=None, codename=None, suite=None, local_vars_configuration=None):  # noqa: E501
        """DebReleaseComponent - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._component = None
        self._distribution = None
        self._codename = None
        self._suite = None
        self.discriminator = None

        self.component = component
        self.distribution = distribution
        self.codename = codename
        self.suite = suite

    @property
    def component(self):
        """Gets the component of this DebReleaseComponent.  # noqa: E501

        Name of the component.  # noqa: E501

        :return: The component of this DebReleaseComponent.  # noqa: E501
        :rtype: str
        """
        return self._component

    @component.setter
    def component(self, component):
        """Sets the component of this DebReleaseComponent.

        Name of the component.  # noqa: E501

        :param component: The component of this DebReleaseComponent.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and component is None:  # noqa: E501
            raise ValueError("Invalid value for `component`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                component is not None and len(component) < 1):
            raise ValueError("Invalid value for `component`, length must be greater than or equal to `1`")  # noqa: E501

        self._component = component

    @property
    def distribution(self):
        """Gets the distribution of this DebReleaseComponent.  # noqa: E501

        Name of the distribution.  # noqa: E501

        :return: The distribution of this DebReleaseComponent.  # noqa: E501
        :rtype: str
        """
        return self._distribution

    @distribution.setter
    def distribution(self, distribution):
        """Sets the distribution of this DebReleaseComponent.

        Name of the distribution.  # noqa: E501

        :param distribution: The distribution of this DebReleaseComponent.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and distribution is None:  # noqa: E501
            raise ValueError("Invalid value for `distribution`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                distribution is not None and len(distribution) < 1):
            raise ValueError("Invalid value for `distribution`, length must be greater than or equal to `1`")  # noqa: E501

        self._distribution = distribution

    @property
    def codename(self):
        """Gets the codename of this DebReleaseComponent.  # noqa: E501


        :return: The codename of this DebReleaseComponent.  # noqa: E501
        :rtype: str
        """
        return self._codename

    @codename.setter
    def codename(self, codename):
        """Sets the codename of this DebReleaseComponent.


        :param codename: The codename of this DebReleaseComponent.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and codename is None:  # noqa: E501
            raise ValueError("Invalid value for `codename`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                codename is not None and len(codename) < 1):
            raise ValueError("Invalid value for `codename`, length must be greater than or equal to `1`")  # noqa: E501

        self._codename = codename

    @property
    def suite(self):
        """Gets the suite of this DebReleaseComponent.  # noqa: E501


        :return: The suite of this DebReleaseComponent.  # noqa: E501
        :rtype: str
        """
        return self._suite

    @suite.setter
    def suite(self, suite):
        """Sets the suite of this DebReleaseComponent.


        :param suite: The suite of this DebReleaseComponent.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and suite is None:  # noqa: E501
            raise ValueError("Invalid value for `suite`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                suite is not None and len(suite) < 1):
            raise ValueError("Invalid value for `suite`, length must be greater than or equal to `1`")  # noqa: E501

        self._suite = suite

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DebReleaseComponent):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DebReleaseComponent):
            return True

        return self.to_dict() != other.to_dict()
